#include <stdio.h>
#include <stdint.h>

#define BI_MAC1		(0x00)

#define MAC_SIZE 	(12)

#define MACFILE0	"/sys/fsl_otp/HW_OCOTP_MAC_ADDR0"
#define MACFILE1	"/sys/fsl_otp/HW_OCOTP_MAC_ADDR1"
#define MACOFFSET0	0x90
#define MACOFFSET1	0x94

static inline int get_mac_addr(char *mac)
{
	int ret;
	uint8_t buf[6];
	uint32_t macfile0_data;
	uint32_t macfile1_data;

	ret = otp_read(MACFILE0, MACOFFSET0, &macfile0_data);
	if (ret)
		return ret;

	ret = otp_read(MACFILE1, MACOFFSET1, &macfile1_data);
	if (ret)
		return ret;

	if ((macfile0_data >> 16) == 0x00 && (macfile0_data >> 8) == 0x11 && macfile0_data == 0x0c) {
		/* AGX3020-P00Z MAC workarond */
		buf[0] = (macfile0_data >> 8);
		buf[1] = macfile0_data;
		buf[2] = macfile1_data >> 24;
		buf[3] = macfile1_data >> 16;
		buf[4] = macfile1_data >> 8;
		buf[5] = macfile1_data;
	} else {
		buf[0] = (macfile1_data >> 8);
		buf[1] = macfile1_data;
		buf[2] = macfile0_data >> 24;
		buf[3] = macfile0_data >> 16;
		buf[4] = macfile0_data >> 8;
		buf[5] = macfile0_data;
	}

	sprintf(mac, "%02x%02x%02x%02x%02x%02x",
		buf[0], buf[1], buf[2],
		buf[3], buf[4], buf[5]);

	return 0;
}
